Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/LODInfo.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/LODInfo.h	(revision 2853)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/LODInfo.h	(revision 2854)
@@ -16,5 +16,5 @@
 struct LODLevel
 {
-	//friend class SceneEntity;
+	friend class SceneEntity;
 
 public:
@@ -22,11 +22,11 @@
 	LODLevel(float squaredDist): mSquaredDistance(squaredDist) {}
 
-	inline float GetSquaredDistance() { return mSquaredDistance; }
+	inline float GetSquaredDistance() const { return mSquaredDistance; }
 
-	inline int GetNumShapes() { return (int)mShapes.size(); }
+	inline int GetNumShapes() const { return (int)mShapes.size(); }
 	
-	inline int GetNumTriangles() { return mNumTriangles; }
+	inline int GetNumTriangles() const { return mNumTriangles; }
 
-	inline Shape *GetShape(size_t i) { return mShapes[i]; }
+	inline Shape *GetShape(size_t i) const { return mShapes[i]; }
 
 	inline ShapeContainer &GetShapes() { return mShapes; }
@@ -37,19 +37,20 @@
 	////////////////
 
-	/** Has to be called each frame in order to use proper LOD level.
+	/** Has to be called each frame in order to initialize the proper LOD level.
 	*/
 	static void InitFrame(const Vector3 &viewPoint);
 
 
+protected:
+
+	static Vector3 sViewPoint;
+	/** The current frame id is used to update LOD.
+	*/
 	static int sFrameId;
-	static Vector3 sViewPoint;
 
-
-
-protected:
 
 	/////////////////////
 
-	float mNumTriangles;
+	int mNumTriangles;
 
 	/// distance of this LOD level
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/deferred.cg
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/deferred.cg	(revision 2853)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/deferred.cg	(revision 2854)
@@ -111,4 +111,6 @@
 
 
+/** Computes ambient occlusion + diffuse reflections
+*/
 float4 globIllum(fragment IN,
 				 uniform sampler2D colors,
@@ -202,4 +204,6 @@
 
 
+/** The mrt shader for screen space ambient occlusion
+*/
 pixel main_ssao(fragment IN, 
 				uniform sampler2D colors,
@@ -268,4 +272,6 @@
 
 
+/** The mrt shader for standard rendering
+*/
 pixel main(fragment IN, 
 		   uniform sampler2D colors,
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderState.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderState.h	(revision 2844)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderState.h	(revision 2854)
@@ -45,5 +45,5 @@
 	*/
 	void SetState(bool texturing, bool alphaTest, bool cullFace);
-	/** Returns wether we are in query or render mode
+	/** Returns either query or render mode
 	*/
 	inline Mode GetMode() const { return mMode; }
@@ -56,11 +56,15 @@
 	/** Returns the current vbo id.
 	*/
-	inline int GetCurrentVboId() { return mCurrentVboId; }
+	inline int GetCurrentVboId() const { return mCurrentVboId; }
 
 	void SetRenderType(RenderType type) { mRenderType = type; }
-	RenderType GetRenderType() { return mRenderType; }
+	RenderType GetRenderType() const { return mRenderType; }
 
 
 	///////////////////
+
+
+	///////////////////
+	//-- for deferred shading, we have to switch shaders on and off
 
 	static CGprofile sCgFragmentProfile;
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 2853)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 2854)
@@ -405,6 +405,6 @@
 	InitGLstate();
 
-	//glEnable(GL_MULTISAMPLE_ARB);
-	//glHint(GL_MULTISAMPLE_FILTER_HINT_NV, GL_NICEST);
+	glEnable(GL_MULTISAMPLE_ARB);
+	glHint(GL_MULTISAMPLE_FILTER_HINT_NV, GL_NICEST);
 
 	InitFBO();
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.vcproj	(revision 2853)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.vcproj	(revision 2854)
@@ -515,4 +515,8 @@
 				</File>
 				<File
+					RelativePath=".\src\FrameBufferObject.h"
+					>
+				</File>
+				<File
 					RelativePath=".\src\Geometry.h"
 					>
@@ -614,4 +618,8 @@
 				<File
 					RelativePath=".\src\chcdemo.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\src\FrameBufferObject.cpp"
 					>
 				</File>